/* $Id: timings.h 91 2004-09-16 15:02:07Z /CN=thome/emailAddress=thome@loria.fr $ */

#ifndef TIMINGS_H_
#define TIMINGS_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned long long fasttimer_t;

extern void push_time(void);
extern void pop_time_raw(void);			// The bare time
extern void pop_time_colon(const char * msg);	// in form ``blah: 3.2s''
extern void discard_timer(void);
extern fasttimer_t lookup_time(void);
extern fasttimer_t read_time(void);

#define pop_time(x)	pop_time_colon(x)

extern void set_timings_file(FILE *);

extern void estimate_arrival(FILE *f, char * msg, double fraction);

extern void timings_set_dispmode(double mode);
extern double look_time_as_sec();

#define	TIMINGS_ARE_HUMAN_READABLE	0
#define	TIMINGS_ARE_MICROSECONDS	1.0
#define	TIMINGS_ARE_MILLISECONDS	1000.0
#define	TIMINGS_ARE_SECONDS		1000000.0
#define	TIMINGS_ARE_MINUTES		60000000.0


#ifdef __cplusplus
}
#endif

#endif	/* TIMINGS_H_ */
