/* $Id: th002.c 91 2004-09-16 15:02:07Z /CN=thome/emailAddress=thome@loria.fr $ */

#include <stdio.h>
#include <stdlib.h>
#include <gmp.h>
#include <math.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>

#include "mploc.h"
#include "z2.h"
#include "z2x.h"
#include "z2n.h"

int main(int argc, char *argv[])
{
	mp_size_t precision;
	int n;
	mploc_z2x_t V, V1, V2;
	mplf_t field;
	mploc_t aux;

	precision = 22;
	n = 3;

	field = mplf_z2_create();
	mploc_z2x_init(V, field);
	mploc_z2x_init(V1, field);
	mploc_z2x_init(V2, field);
	mploc_z2_init(aux, field);

	/* V1 = 396*X + 396*X^2 + 2047*X^3 + O(2^33) */
	mploc_z2x_set_ui(V1, 0, precision);
	mploc_z2_set_ui(aux, 396, precision);
	mploc_z2x_set_coeff(V1, 1, aux);
	mploc_z2x_set_coeff(V1, 2, aux);
	mploc_z2_set_ui(aux, 2047, precision);
	mploc_z2x_set_coeff(V1, 3, aux);

	/* V2 = 1 + 91*X + 90*X^2 + 2047*X^3 + O(2^22) */
	mploc_z2x_set_ui(V2, 1, precision);
	mploc_z2_set_ui(aux, 91, precision);
	mploc_z2x_set_coeff(V2, 1, aux);
	mploc_z2_set_ui(aux, 90, precision);
	mploc_z2x_set_coeff(V2, 2, aux);
	mploc_z2_set_ui(aux, 2047, precision);
	mploc_z2x_set_coeff(V2, 3, aux);

	/* V1 = 2^11*V1 */
	mploc_z2x_lshift(V1, V1, 11);

	mploc_z2x_add(V1, V1, V2);

	mploc_z2x_clear(V);
	mploc_z2x_clear(V1);
	mploc_z2x_clear(V2);
	mploc_z2_clear(aux);
	return 0;
}
