/* $Id: th005.c 91 2004-09-16 15:02:07Z /CN=thome/emailAddress=thome@loria.fr $ */

#include <stdio.h>
#include <stdlib.h>
#include <gmp.h>
#include <math.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>

#include "mploc.h"
#include "z2.h"
#include "z2x.h"

int main(int argc, char *argv[])
{
	mp_size_t precision;
	int n;
	mplf_t field;
	mploc_z2x_t V, Delta;
	mploc_t aux;

	precision = 32;
	n = 3;

	field = mplf_z2_create();
	mploc_z2x_init(V, field);
	mploc_z2x_init(Delta, field);
	mploc_z2_init(aux, field);

	/* V = 2147483646*X + 2147483647*X^2 + 3*X^3 + O(2^32) */
	mploc_z2x_set_ui(V, 0, precision);
	mploc_z2_set_ui(aux, 2147483646, precision);
	mploc_z2x_set_coeff(V, 1, aux);
	mploc_z2_set_ui(aux, 2147483647, precision);
	mploc_z2x_set_coeff(V, 2, aux);
	mploc_z2_set_ui(aux, 3, precision);
	mploc_z2x_set_coeff(V, 3, aux);

	/* V->cw = 2 */
	mploc_z2x_lshift(V, V, 32);
	mploc_z2x_rshift(V, V, 32);

	/* V = V (mod 4) */
	mploc_z2x_insert_zero(V, 2);

	/* Delta = 0 */
	mploc_z2x_set_ui(Delta, 0, precision);

	mploc_z2x_neg(Delta, V);

	return 0;
}
