/* $Id: rf_layer_gfpn_ntl.hpp 91 2004-09-16 15:02:07Z /CN=thome/emailAddress=thome@loria.fr $ */

#ifndef	GFPN_RESIDUEL_FIELD_LAYER_H_
#define GFPN_RESIDUEL_FIELD_LAYER_H_

#define ATTACH_RESIDUE_FIELD(f)		ntl_attach_GFPE(f)
#define DETACH_RESIDUE_FIELD(f)		ntl_detach_GFPE(f)

#ifdef	__cplusplus
extern "C" {
#endif

#define rf_name(x)	gfpn_ ## x

#define	new_rfe(x)		rf_name(new_rfe)(x)
#define	_delete_rfe(x,y)	rf_name(_delete_rfe)(x,y)
#define rfe_set_mploc(a,b,c)	rf_name(rfe_set_mploc)(a,b,c)
#define rfe_set_mploc_coeff(a,b,c,d)	rf_name(rfe_set_mploc_coeff)(a,b,c,d)
#define mploc_coeff_set_rfe(a,b,c,d)	rf_name(mploc_coeff_set_rfe)(a,b,c,d)
#define mploc_set_rfe(a,b,c)	rf_name(mploc_set_rfe)(a,b,c)
#define RF_sqrt(a,b,c)		rf_name(RF_sqrt)(a,b,c)
#define RF_inv(a,b,c)		rf_name(RF_inv)(a,b,c)
#define RF_invsqrt(a,b,c)	rf_name(RF_invsqrt)(a,b,c)
#define RF_is_zero(a,b)		rf_name(RF_is_zero)(a,b)
#define RF_mul(a,b,c,d)		rf_name(RF_mul)(a,b,c,d)
		

typedef	void * rf_elt;	/* No choice :-( */

extern void ntl_attach_GFPE(mplf_t f);
extern void ntl_detach_GFPE(mplf_t f);

extern rf_elt new_rfe(mplf_t);
extern void _delete_rfe(rf_elt *, mplf_t);
#define delete_rfe(x,f) _delete_rfe(&(x),f)
extern void rfe_set_mploc(rf_elt, mploc_zpx_srcptr, mplf_t);
extern void mploc_set_rfe(mploc_zpx_ptr, rf_elt, mplf_t);

extern void mploc_coeff_set_rfe(mploc_zpx_ptr, mp_size_t, rf_elt, mplf_t);
extern void rfe_set_mploc_coeff(rf_elt, mploc_zpx_srcptr, mp_size_t, mplf_t);

/* Provide a macro for each operation */
extern int RF_sqrt(rf_elt y,rf_elt x, mplf_t f);
extern void RF_inv(rf_elt y,rf_elt x, mplf_t f);
extern void RF_mul(rf_elt z, rf_elt y,rf_elt x, mplf_t f);
extern int RF_invsqrt(rf_elt y,rf_elt x, mplf_t f);
extern int RF_is_zero(rf_elt x, mplf_t f);

#ifdef  __cplusplus
}
#endif

#endif	/* GFPN_RESIDUEL_FIELD_LAYER_H_ */
