/* $Id: rf_layer_prime.h 91 2004-09-16 15:02:07Z /CN=thome/emailAddress=thome@loria.fr $ */

#ifndef PRIME_RESIDUE_FIELD_LAYER_H_
#define PRIME_RESIDUE_FIELD_LAYER_H_

/*
 * This is *one* implementation of a prime field bottom layer.
 * Other implementations, in theory, can be easily provided.
 */

#include "field_def.h"
#include "field_prime.h"

#define RF(f)	((struct field *)((f)->residue_field))
#define RF_LVAL(f)	((f)->residue_field)
#define RF_LVAL_DESTTYPE_CAST	(void*)

#define ATTACH_RESIDUE_FIELD(f)	\
	RF_LVAL(f) = RF_LVAL_DESTTYPE_CAST	\
	new_prime_field((f)->p->_mp_d,(f)->p->_mp_size)


#define DETACH_RESIDUE_FIELD(f)		\
	BEGIN_BLOCK			\
		RF(f)->destroy(RF(f));	\
		RF_LVAL(f)=RF_LVAL_DESTTYPE_CAST NULL;		\
	END_BLOCK

typedef mp_limb_t * rf_elt;

#define rf_name(x)	gfp_ ## x

#define	new_rfe(x)		rf_name(new_rfe)(x)
#define	_delete_rfe(x,y)	rf_name(_delete_rfe)(x,y)
#define rfe_set_mploc(a,b,c)	rf_name(rfe_set_mploc)(a,b,c)
#define mploc_set_rfe(a,b,c)	rf_name(mploc_set_rfe)(a,b,c)

extern rf_elt new_rfe(mplf_t);
extern void _delete_rfe(rf_elt *, mplf_t);
#define delete_rfe(x,f) _delete_rfe(&(x),f)
extern void rfe_set_mploc(rf_elt, mploc_srcptr, mplf_t);
extern void mploc_set_rfe(mploc_ptr, rf_elt, mplf_t);

/* Provide a macro for each operation */
#define RF_sqrt(y,x,f)	RF(f)->sqrt(y,x,RF(f))
#define RF_inv(y,x,f)	RF(f)->inv(y,x,RF(f))
#define RF_is_zero(x,f)	RF(f)->is_int(x,0,RF(f))

#endif	/* PRIME_RESIDUE_FIELD_LAYER_H_ */
