/* $Id: z2_limbs.h 91 2004-09-16 15:02:07Z /CN=thome/emailAddress=thome@loria.fr $ */

#ifndef Z2_LIMBS_H_
#define Z2_LIMBS_H_

#ifdef __cplusplus
extern "C" {
#endif

#define mploc_limbs_copy(dst,src,n) memcpy((dst),(src),(n)*sizeof(mp_limb_t))
#define mploc_limbs_move(dst,src,n) memmove((dst),(src),(n)*sizeof(mp_limb_t))
#define mploc_limbs_zero(dst,n)     memset((dst),0,(n)*sizeof(mp_limb_t))

extern void mploc_limbs_insert_zero(mp_limb_t *, mp_size_t, mp_size_t);
extern void mploc_limbs_sign_extend(mp_limb_t *, mp_size_t, mp_size_t);
extern int mploc_limbs_are_zero(const mp_limb_t *, mp_size_t);
extern int mploc_limbs_are_equal(const mp_limb_t *,const mp_limb_t *,
					mp_size_t);
extern void mploc_limbs_neg(mp_limb_t *, const mp_limb_t *, mp_size_t);
extern void mploc_limbs_short_product(mp_limb_t *, const mp_limb_t *,
				const mp_limb_t *, mp_limb_t *, mp_size_t);
extern void mploc_limbs_short_square(mp_limb_t *, const mp_limb_t *,
				mp_limb_t *, mp_size_t);
extern mp_limb_t mploc_limbs_short_square_carry(mp_limb_t *, const mp_limb_t *,
				mp_limb_t *, mp_size_t);
extern int mploc_limbs_valuation(const mp_limb_t *, mp_size_t);


#ifdef __cplusplus
}
#endif

#endif	/* Z2_LIMBS_H_ */
